set TSdebug 0

if {[info exists env(OrbixTapeManager)] == 0} then {
   set resource eb64
} else {
   set resource $env(OrbixTapeManager)
}
set server "$resource"

set drive "MT"
set type  "MT"
set typeindex 1
set typelist {JB MT F}
set typenameslist {Exabyte Box}

# This list should be set to (or greater than) the maximum number of
# tape drives to be managed, includeing SINKs and FILEs

set aliases {0 1 2 3 4 5}
foreach al $aliases {set initvols($al) ""}
set units 1

set ORBreport 0

proc ORB {x} {
   global debug ORBreport
   global srv
   if {$debug} then {puts stdout "($x)"} 
   if {$ORBreport != 0} then {set-footer "executing $srv $x"}
   set z [catch {$srv "($x)"} m]
   if {$z!=0} then {
     display-$srv-error-report self $m "accessing $srv $x"
     clear-footer
     error $m
   }
   clear-footer
   return $m
}

proc display-orb-error-report {p e args} {
   if {$e<16} then {
      set m [expr 0x40000 + $e]
      set e [format "0x%x" $m]
   }
   switch [llength $args] {
      1 {display-midas-error-report $p $e "ORBIX ERROR:" [first $args]}
      2 {display-midas-error-report $p $e "ORBIX ERROR:" [first $args] [second $args]}
      3 {display-midas-error-report $p $e "ORBIX ERROR:" [first $args] [second $args] [third $args]}
      4 {display-midas-error-report $p $e "ORBIX ERROR:" [first $args] [second $args] [third $args] [fourth $args]}
      5 {display-midas-error-report $p $e "ORBIX ERROR:" [first $args] [second $args] [third $args] [fourth $args] [fifth $args]}
      default {display-midas-error-report $p $e "ORBIX ERROR:" [first $args] [second $args] [third $args] [fourth $args] [fifth $args] [sixth $args]}
   }
}

#------------------------------------------------------------------------
proc claimTS {} {
  global TSdebug env
  global l
  global server srv

 set z [catch {$srv "(tape :path '$server' !claimman)"} m]

 if {$TSdebug > 1} then {puts stdout "claim tape manager:  $m"}

 if {$z!=0} then {
      display-$srv-error-report self $m "Attempting Orbix tape manager claim"
      clear-footer
      error $m
  }
 if {$z != 0} then {
   if {$TSdebug != 0} then {puts stdout  "claimTS returned code= $m"}
   return -code error $m
 }

 return -code ok 0
}

#-------------------
proc freeTS {} {
  global TSdebug env
  global l
  global server srv

 set z [catch {$srv "(tape :path '$server' !freeman)"} m]

 if {$TSdebug > 1} then {puts stdout "free tape manager:  $m"}

 if {$z != 0} then {
   if {$TSdebug != 0} then {puts stdout  "freeTS returned code= $m"}
   return -code error $m
 }

 if {$TSdebug > 1} then {puts stdout "freeTS returned code= $m"}

 return -code ok $m
}

#-------------------
proc resumeTS {} {
   global env
   global server srv

   if {[info exists env(EXPERIMENTDIR)]} then {
      $srv "(tape :path '$env(EXPERIMENTDIR)' :name 'OrbixTS' !connect)"
   }
}

#-------------------
proc relinquishTS {} {
  global env
  global server srv

   $srv "(tape !disconnect)"
}
