

#    MIDAS Access Client  for the  Tape Server service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global TapeServerHost TapeServerPort

if {[info exists TapeServerHost] == 0} then {set TapeServerHost localhost}
if {[info exists TapeServerPort] == 0} then {set TapeServerPort 8015}

variable uri "urn:TapeServer"
variable proxy "http://$TapeServerHost:$TapeServerPort/TapeServer"


SOAP::create TapeClient__MountVolume -proxy $proxy -uri $uri -timeout 5000 \
     -name MountVolume \
     -params {id string volume_name string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__OpenFile -proxy $proxy -uri $uri -timeout 5000 \
     -name OpenFile \
     -params {id string access_mode int label_type int record_length int block_length int file_name string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__CloseFile -proxy $proxy -uri $uri -timeout 5000 \
     -name CloseFile \
     -params {id string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__DismountVolume -proxy $proxy -uri $uri -timeout 5000 \
     -name DismountVolume \
     -params {id string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__InquireDeviceStatus -proxy $proxy -uri $uri -timeout 5000 \
     -name InquireDeviceStatus \
     -params {id string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__InquireStreamStatus -proxy $proxy -uri $uri -timeout 5000 \
     -name InquireStreamStatus \
     -params {id string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__DeallocateDevice -proxy $proxy -uri $uri -timeout 5000 \
     -name DeallocateDevice \
     -params {id string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__IdentifyVolume -proxy $proxy -uri $uri -timeout 5000 \
     -name IdentifyVolume \
     -params {id string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__InquireAvailableDevices -proxy $proxy -uri $uri -timeout 5000 \
     -name InquireAvailableDevices \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__ClaimTapeServer -proxy $proxy -uri $uri -timeout 5000 \
     -name ClaimTapeServer \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__FreeTapeServer -proxy $proxy -uri $uri -timeout 5000 \
     -name FreeTapeServer \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__InquireTapeServerState -proxy $proxy -uri $uri -timeout 5000 \
     -name InquireTapeServerState \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__InquireAcqStatus -proxy $proxy -uri $uri -timeout 5000 \
     -name InquireAcqStatus \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__SetTapeServerState -proxy $proxy -uri $uri -timeout 5000 \
     -name SetTapeServerState \
     -params {int state} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__InquireStreamAssociation -proxy $proxy -uri $uri -timeout 5000 \
     -name InquireStreamAssociation \
     -params {int stream} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__InquireStreamState -proxy $proxy -uri $uri -timeout 5000 \
     -name InquireStreamState \
     -params {int stream} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__SetRunNumber -proxy $proxy -uri $uri -timeout 5000 \
     -name SetRunNumber \
     -params {int n} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create TapeClient__InitialiseVolume -proxy $proxy -uri $uri -timeout 5000 \
     -name InitialiseVolume \
     -params {id string volume_name string label_type int density_code int current_volume_name string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__AllocateDevice -proxy $proxy -uri $uri -timeout 5000 \
     -name AllocateDevice \
     -params {id string device_name string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create TapeClient__AssociateStream -proxy $proxy -uri $uri -timeout 5000 \
     -name AssociateStream \
     -params {int stream ids string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply  

SOAP::create TapeClient__ServerVerbose -proxy $proxy -uri $uri -timeout 5000 \
     -name ServerVerbose \
     -params {opt string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply


global TapeClient__Methods
set TapeClient__Methods {MountVolume OpenFile CloseFile DismountVolume InquireDeviceStatus InquireStreamStatus DeallocateDevice IdentifyVolume \
    InquireAvailableDevices ClaimTapeServer FreeTapeServer InquireTapeServerState InquireAcqStatus SetTapeServerState InquireStreamAssociation \
    InquireStreamState SetRunNumber InitialiseVolume AllocateDevice AssociateStream ServerVerbose}



package provide TapeClient 1.0



