/*
    "ebdatacomms.h" ... Eurogam phase 2 Event Builder include file ... 
    Defines structures used in event-by-event data transfers
    between input controller and Event processors,
    and between Event processors and output controller 
*/

/* Input/Output controller queue handling per Event processor ... */

struct data_transfer {
  volatile int *qbase;
  volatile int qstart;
  volatile int qend;
  volatile int qlength;
  };

/* Data transfer buffer status conditions ... */

#define BUFFER_FREE                             0
#define BUFFER_IN_USE                           1
#define BUFFER_REMOTE                           2
#define BUFFER_READY                            3

/* Data transfer buffer control record formats ... */

struct eg_data_struct {
  int status;
  int *address;
  int length;
  short sequence;
  short stream;
  int procnum;
  int spare2;
  int spare3;
  int spare4;
  };

/* IO communication command types ... */

#define INPUT_ACK                               0
#define INPUT_REQUEST                           1
#define OUTPUT_REQUEST                          2


