#  V785.defn.tcl

if {![info exists adcInc]} {set adcInc 1}
if {![info exists maxadc]} {set maxadc 32}

proc {Add_CAEN V785_Module} {name server addressdata} {
   global CurrentVMEServer maxadc adcInc

   if {$adcInc==2} then {set threshInc 4} else {set threshInc 2}

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]
   set interruptlevel [fourth $addressinfo]
   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server
 
   define-vme-register $name xVME Firmware_Rev        "-a$A32addrbase -w32 -o0x1000 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME GEO_Address         "-a$A32addrbase -w32 -o0x1002 -prw -d16 -l5 -b0 -zx -i$moduleID"
   define-vme-register $name xVME MCST|CBLT_Address   "-a$A32addrbase -w32 -o0x1004 -prw -d16 -l8 -b0 -zx -i0xAA"
   define-vme-register $name xVME Bit_Set_1           "-a$A32addrbase -w32 -o0x1006 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Bit_Clear_1         "-a$A32addrbase -w32 -o0x1008 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Intr_Level          "-a$A32addrbase -w32 -o0x100a -prw -d16 -l3 -b0 -zd -i$interruptlevel"
   define-vme-register $name xVME Intr_Vec            "-a$A32addrbase -w32 -o0x100c -prw -d16 -l8 -b0 -zd -i$interruptvector"

   define-vme-register $name xVME Status1             "-a$A32addrbase -w32 -o0x100e -pro -d16 -l9 -b0 -zx"
   define-vme-register $name xVME Status1.Term        "-a$A32addrbase -w32 -o0x100e -pro -d16 -l2 -b6 -zd"
   define-vme-register $name xVME Status1.DReady      "-a$A32addrbase -w32 -o0x100e -pro -d16 -l1 -b0 -zd"

   define-vme-register $name xVME Ctrl1               "-a$A32addrbase -w32 -o0x1010 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Ctrl1.BERR          "-a$A32addrbase -w32 -o0x1010 -prw -d16 -l1 -b5 -zd"
   define-vme-register $name xVME ADER_HIGH           "-a$A32addrbase -w32 -o0x1012 -prw -d16 -l8 -b0 -zx"
   define-vme-register $name xVME ADER_LOW            "-a$A32addrbase -w32 -o0x1014 -prw -d16 -l8 -b0 -zx"
   define-vme-register $name xVME MCST|CBLT_Ctrl      "-a$A32addrbase -w32 -o0x101a -pwo -d16 -l2 -b0 -zx"
   define-vme-register $name xVME Event_Trig          "-a$A32addrbase -w32 -o0x1020 -prw -d16 -l5 -b0 -zx"

   define-vme-register $name xVME Status2             "-a$A32addrbase -w32 -o0x1022 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Status2.Bbits       "-a$A32addrbase -w32 -o0x1022 -pro -d16 -l2 -b1 -zd"

   define-vme-register $name xVME EvCounter_Low       "-a$A32addrbase -w32 -o0x1024 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME EvCounter_High      "-a$A32addrbase -w32 -o0x1026 -pro -d16 -l8 -b0 -zx"
   define-vme-register $name xVME Incr_Event          "-a$A32addrbase -w32 -o0x1028 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Incr_Offset         "-a$A32addrbase -w32 -o0x102a -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Fast_Clear_Window   "-a$A32addrbase -w32 -o0x102e -prw -d16 -l0 -b0 -zd"
   define-vme-register $name xVME Bit_Set_2           "-a$A32addrbase -w32 -o0x1032 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Bit_Clear_2         "-a$A32addrbase -w32 -o0x1034 -prw -d16 -l0 -b0 -zx"
   define-vme-register $name xVME W_Mem_Test_Addr     "-a$A32addrbase -w32 -o0x1036 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Mem_Test_High       "-a$A32addrbase -w32 -o0x1038 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Mem_Test_Low        "-a$A32addrbase -w32 -o0x103a -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Crate               "-a$A32addrbase -w32 -o0x103c -prw -d16 -l8 -b0 -zd -i1"
   define-vme-register $name xVME Test_Event_Data     "-a$A32addrbase -w32 -o0x103e -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME EvCounter_Reset     "-a$A32addrbase -w32 -o0x1040 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME R_Mem_Test_Addr     "-a$A32addrbase -w32 -o0x1064 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME SW_Comm             "-a$A32addrbase -w32 -o0x1068 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Slide               "-a$A32addrbase -w32 -o0x106a -prw -d16 -l8 -b0 -zx"
   define-vme-register $name xVME AAD                 "-a$A32addrbase -w32 -o0x1070 -pro -d16 -l12 -b0 -zx"
   define-vme-register $name xVME BAD                 "-a$A32addrbase -w32 -o0x1072 -pro -d16 -l12 -b0 -zx"
   for {set i 0; set off 0x1080} {$i < $maxadc} {incr i $adcInc; incr off $threshInc} {
      define-vme-register $name xVME Threshold$i      "-a$A32addrbase -w32 -o$off -prw -d16 -l8 -b0 -zd -i16"
      define-vme-register $name xVME Disable$i        "-a$A32addrbase -w32 -o$off -prw -d16 -l1 -b8 -zd -i0"
   }
   define-vme-register $name xVME ROM.OUI_MSB         "-a$A32addrbase -w32 -o0x8026 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ROM.OUI             "-a$A32addrbase -w32 -o0x802a -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ROM.OUI_LSB         "-a$A32addrbase -w32 -o0x802e -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ROM.Version         "-a$A32addrbase -w32 -o0x8032 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ROM.BID_MSB         "-a$A32addrbase -w32 -o0x8036 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ROM.BID             "-a$A32addrbase -w32 -o0x803a -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ROM.BID_LSB         "-a$A32addrbase -w32 -o0x803e -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ROM.Rev             "-a$A32addrbase -w32 -o0x804e -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ROM.Ser_MSB         "-a$A32addrbase -w32 -o0x8f02 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ROM.Ser_LSB         "-a$A32addrbase -w32 -o0x8f06 -pro -d16 -l0 -b0 -zx"

   define-vme-register $name bVME Output_Buffer       "-a$A32addrbase -w32 -o0x0 -pro -d32 -zx -m0x0b -l64"
   define-vme-register $name xVME Output_Word         "-a$A32addrbase -w32 -o0x0 -pro -d32 -l0 -b0 -zx"
}

proc {CAEN V785_registers} {} {
    global registers_table maxadc adcInc

    set registers_table   {                                              \
        {"Firmware Revision Register"          Firmware_Rev}             \
        {"GEO Address Register"                GEO_Address}              \
        {"MCST|CBLT Address Register"          MCST|CBLT_Address}        \
        {"Bit Set 1 Register"                  Bit_Set_1}                \
        {"Bit Clear 1 Register"                Bit_Clear_1}              \
        {"Interrupt Level Register"            Intr_Level}               \
        {"Interrupt Vector Register"           Intr_Vec}                 \
        {"Status Register 1"                   Status1}                  \
        {"Control Register 1"                  Ctrl1}                    \
        {"Address Decoder High Register"       ADER_HIGH}                \
        {"Address Decoder Low Register"        ADER_LOW}                 \
        {"Event Trigger Register"              Event_Trig}               \
        {"Status Register 2"                   Status2}                  \
        {"Event Counter_Low Register"          EvCounter_Low}            \
        {"Event Counter_High Register"         EvCounter_High}           \
        {"Fast Clear Window Register"          Fast_Clear_Window}        \
        {"Bit Set 2 Register"                  Bit_Set_2}                \
        {"Bit Clear 2 Register"                Bit_Clear_2}              \
        {"Crate Select Register"               Crate}                    \
        {"Slide Constant Register"             Slide}                    \
        {"AAD Register"                        AAD}                      \
        {"BAD Register"                        BAD}                      \
        {"ROM OUI MSB"                         ROM.OUI_MSB}              \
        {"ROM OUI"                             ROM.OUI}                  \
        {"ROM OUI LSB"                         ROM.OUI_LSB}              \
        {"ROM Version"                         ROM.Version}              \
        {"ROM Board ID MSB"                    ROM.BID_MSB}              \
        {"ROM Board ID"                        ROM.BID}                  \
        {"ROM Board ID LSB"                    ROM.BID_LSB}              \
        {"ROM Revision"                        ROM.Rev}                  \
        {"ROM Serial MSB"                      ROM.Ser_MSB}              \
        {"ROM Serial LSB"                      ROM.Ser_LSB}              \
    }
    for {set i 0} {$i < $maxadc} {incr i $adcInc} {
        lappend registers_table [list "Threshold Memory ch$i"  Threshold$i]
        lappend registers_table [list "Disable ch$i"  Disable$i]
    }
}


proc CAENV785_reset-module {module} {
    global {CAEN V785_registersavepatterns}

#    save volatile registers which will be reset by a board software reset
    foreach r [set {CAEN V785_registersavepatterns}] {
        if {$r == "Threshold*" || $r == "Disable*"} continue
        set $r [read-vme-register $module.$r]
    }

#    software reset the board
    write-vme-register $module.Bit_Set_1 0x80
    write-vme-register $module.Bit_Clear_1 0x80

#    and restore the volatile registers
    foreach r [set {CAEN V785_registersavepatterns}] {
        if {$r == "Threshold*" || $r == "Disable*"} continue
        write-vme-register $module.$r [set $r]
    }
}

proc {CAEN V785_DAQ-reset} {args} {
#   V785
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.Firmware_Rev] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff

     CAENV785_reset-module $module

#    always generate event header
    write-vme-register $module.Bit_Set_2 0x1000
#    no overflow suppression
    write-vme-register $module.Bit_Set_2 0x8
}

proc {CAEN V785_DAQ-flush} {args} {
#   V785
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

     CAENV785_reset-module $module

#    always generate event header
    write-vme-register $module.Bit_Set_2 0x1000
#    no overflow suppression
    write-vme-register $module.Bit_Set_2 0x8
}

proc {CAEN V785_DAQ-go} {args} {
#   V785
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#    clear the data
    write-vme-register $module.Bit_Set_2 4
    write-vme-register $module.Bit_Clear_2 4
#
    write-vme-register $module.Ctrl1.BERR 1
}

proc {CAEN V785_DAQ-halt} {args} {
#   V785
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {CAEN V785_DAQ-setup} {args} {
#   V785
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#    software reset the board
    write-vme-register $module.Bit_Set_1 0x80
    write-vme-register $module.Bit_Clear_1 0x80

#    initialise 
    initialise-vme-registers $module.*
    write-vme-register $module.GEO_Address [third $args]

#    always generate event header
    write-vme-register $module.Bit_Set_2 0x1000
#    no overflow suppression
    write-vme-register $module.Bit_Set_2 0x8
}

#   for parameter save/restore
set {CAEN V785_registersavepatterns} {Threshold* Disable* Fast_Clear_Window Slide Bit_Set_2}


